/*_______________________________________________________________________________________________________________________________________________________________*

*FINANCILA LITERACY +INEP 
 DATA CONSISTENCY	

 *Writen by: Isabela Furtado   -  isabelabfurtado@gmail.com using stata12
INT_ENM_RESULTADO_2018

Mark out of sample     47 inconsistencies in school -> census_merge==3

Mark out of sample     25 inconsistencies in grade
Test compatível com a sere de FL, a mairia não fez a prova

Transferencias  768  sendo  602  para escolas com o programa de FL e 162  para fora

Correct  7,250  gender information 
*_______________________________________________________________________________________________________________________________________________________________*/
	
	
	***Consistency check of INEP Merge
	/*
*************************************************************************************************************************
	*1) Lista de escolas no sorteio de educação financeira por série dos alunos 
*************************************************************************************************************************	
	insheet using "$dtraw\Fin_Lit_pooled_data_raw.csv", clear
	format student_key %20.0g
	format teacher*_key  %20.0g

	keep cd_escola resultado cd_etapa_aplicacao_turma 
	duplicates drop cd_escola cd_etapa_aplicacao_turma, force
	
	gen serie=1
	reshape wide serie, i(cd_escola) j(cd_etapa_aplicacao_turma)
	
	gen co_entidade_2015 			= cd_escola
	gen co_entidade_sit_2015 		= cd_escola
	
	gen treat_co_entidade_2015     = resultado
	gen treat_co_entidade_sit_2015 = resultado

	save "$dtfinal\List_school.dta", replace

*************************************************************************************************************************
	*2) Gera a lista de código de alunos- parar merge na base do censo. 
*************************************************************************************************************************	
	use  "$dtfinal\Fin_Lit_INEP_merge.dta",replace
	
	keep  student_key co_pessoa_fisica cd_escola serie

	export excel using "T:\Data\list_person_codes.xls", firstrow(variables)
	
*************************************************************************************************************************
	*3)Merge using SAS ALUNOS-> CENSO-> id_turma
*************************************************************************************************************************	
	*censo_escolar 2015 e list_person_codes by  co_pessoa_fisica -> resultado list_codes_class
	*base contem o código das turmas em 2015

*************************************************************************************************************************
	*4)Base de alunos com código da turma, remover duplicatas para ter todos os códigos de turma de uma escola
*************************************************************************************************************************	
	
	*Remove duplicates para cruzar com dados da truma no INEP
	insheet using "T:\Data\list_codes_class.csv", delimiter(";") clear
		
	duplicates drop id_turma, force
	keep id_turma co_entidade
	export excel using "T:\Data\deduplicates_list_class_codes.xls", firstrow(variables)
*************************************************************************************************************************
	*5)Merge using SAS TURMA-> CENSO_TURMAS-> id_turma= nome_turma
*************************************************************************************************************************	
	
	*/
*************************************************************************************************************************
	*6)Conferencias basicas- escola e turma dos alunos, serie, etc.
*************************************************************************************************************************	
	insheet using "T:\Data\list_codes_class.csv", delimiter(";") clear
	format student_key %20.0g
	format co_pessoa_fisica*  %20.0g	
	
	*Drop variables that are not used:
	drop co_projeto co_evento co_pessoa_fisica1 nu_dur_ativ_comp_mesma_rede nu_dur_ativ_comp_outras_redes nu_dur_aee_mesma_rede nu_dur_aee_outras_redes ///
	nu_dias_atividade tp_nacionalidade tp_cor_raca tp_sexo co_pais_origem co_uf_nasc co_uf_end tp_zona_residencial tp_outro_local_aula in_transporte_publico ///
	tp_responsavel_transporte in_transp_vans_kombi in_transp_micro_onibus in_transp_onibus in_transp_bicicleta in_transp_tr_animal in_transp_outro_veiculo ///
	in_transp_embar_ate5 in_transp_embar_5a15 in_transp_embar_15a35 in_transp_embar_35 in_transp_trem_metro in_necessidade_especial in_cegueira in_baixa_visao ///
	in_surdez in_def_auditiva in_surdocegueira in_def_fisica in_def_intelectual in_def_multipla in_autismo in_autismo in_sindrome_asperger in_sindrome_rett ///
	in_transtorno_di in_superdotacao in_recurso_ledor in_recurso_transcricao in_recurso_interprete in_recurso_libras in_recurso_labial in_recurso_braille ///
	in_recurso_ampliada_16 in_recurso_ampliada_20 in_recurso_ampliada_24 in_recurso_nenhum tp_ingresso_federais tp_mediacao_didatico_pedago co_curso_educ_profissional ///
	co_regiao co_mesorregiao co_microrregiao co_uf co_distrito tp_dependencia tp_localizacao tp_categoria_escola_privada in_conveniada_pp tp_convenio_poder_publico ///
	in_mant_escola_privada_emp in_mant_escola_privada_ong in_mant_escola_privada_sind in_mant_escola_privada_sist_s in_mant_escola_privada_s_fins tp_regulamentacao ///
	tp_localizacao_diferenciada in_educacao_indigena
	
	tempfile list_codes
	save `list_codes', replace
 
 	insheet using "T:\Data\list_class_codes_names.csv", delimiter(";") clear
	merge 1:n id_turma co_entidade using   `list_codes'
	drop _merge

 
	*Drop duplicates:
	*0 - Não possui atendimento diferenciado
	*1 - Classe hospitalar
	*2 - Unidade de atendimento socioeducativo
	*3 - Unidade prisional
	*4 - Atividade complementar
	*5 - Atendimento Educacional Especializado (AEE)"
	keep if tp_tipo_turma==0
	
	*Duplicates: more then one regular class
	duplicates tag co_pessoa_fisica, gen(dupl_cpf)
	
	*keep schcools in list
	drop if co_entidade!=cd_escola & dupl_cpf==1

	drop dupl_cpf
	duplicates tag co_pessoa_fisica, gen(dupl_cpf)
	tab dupl_cpf
	drop dupl_cpf
	
	drop student_key  cd_escola serie
	
	merge n:1 co_pessoa_fisica using "$dtfinal\Fin_Lit_INEP_merge.dta"

	drop _merge
	order student_key cd_escola serie co_pessoa_fisica co_entidade id_turma no_turma
 
	sort cd_escola co_entidade id_turma no_turma
	
 
	**************************
	*Checks
	**************************
	replace  in_inep=.c if census_merge==.

*****************	
**School
*****************	

	gen    check_school= 1 if cd_escola==co_entidade_2015 | cd_escola==co_entidade_sit_2015
	recode check_school .=0 if co_entidade_2015 !=.
	
	tab census_merge check_school
	
	replace in_inep=.a if check_school==0
	*Alunos com merge fora da escola foram desconsiderados
	
	*Treatemt status escola co_entidade_2015 co_entidade_sit_2015
	merge n:1 co_entidade_2015     using "$dtfinal\List_school.dta",  keepusing(treat_co_entidade_2015)
	drop if _merge==2
	rename _merge merge_t_co_entidade_2015
	merge n:1 co_entidade_sit_2015 using "$dtfinal\List_school.dta",  keepusing(treat_co_entidade_sit_2015)
	drop if _merge==2
	rename _merge merge_t_co_entidade_sit_2015
	
	*Total de alunos por turma
	gen s=1
	bysort co_entidade id_turma:  egen total_turma=total(s)
	drop s

	**Mudanças de turma são justificadas por transferencias de escola	 
	gen transf=1 if co_entidade_2015!=co_entidade_sit_2015
	
	gen transf_in =1 if cd_escola==co_entidade_sit_2015 & cd_escola!=co_entidade_2015
	gen transf_out=1 if cd_escola!=co_entidade_sit_2015 & cd_escola==co_entidade_2015

	tab transf d, mis
	tab transf_in d, mis
	tab transf_out d, mis
	
	lab var transf "Flag school transference"
	
	foreach var in  transf transf_in transf_out{
	recode `var'  .=0 if co_entidade_sit_2015!=.
	}
	sort cd_escola serie census_merge
	
	*br   cd_escola	co_entidade_2015 co_entidade_sit_2015	serie grade_sit_2015	no_turma nm_turma	transf resultado treated_espec1 treated_espec2
	
*****************		
**Grade
*****************	

	gen     check_grade=1 if serie==3 & (tp_etapa_ensino_2015==5   | tp_etapa_ensino_sit_2015==5  | tp_etapa_ensino_2015==16 | tp_etapa_ensino_sit_2015==16 )
	replace check_grade=1 if serie==5 & (tp_etapa_ensino_2015==7   | tp_etapa_ensino_sit_2015==7  | tp_etapa_ensino_2015==18 | tp_etapa_ensino_sit_2015==18 )
	replace check_grade=1 if serie==7 & (tp_etapa_ensino_2015==9   | tp_etapa_ensino_sit_2015==9  | tp_etapa_ensino_2015==20 | tp_etapa_ensino_sit_2015==20 )
	replace check_grade=1 if serie==9 & (tp_etapa_ensino_2015==11  | tp_etapa_ensino_sit_2015==11 | tp_etapa_ensino_2015==41 | tp_etapa_ensino_sit_2015==41 )
	recode  check_grade .=0 if tp_etapa_ensino_2015!=.
	
	br cd_escola co_entidade_2015 co_entidade_sit_2015 serie grade_sit_2015 tp_etapa_ensino_2015  tp_etapa_ensino_sit_2015 d002_total d003_total d005_total if check_grade==0
		
	tab check_grade
	tab check_grade fl_blank_score, mis
	tab check_grade fl_socio_blank, mis 
	tab check_grade fl_blank_parent, mis
	
	replace in_inep=.b if check_grade==0

*****************	
**Gender
*****************	

	gen     check_gender=1   if tp_sexo_2015==1 & gender==1 
	replace check_gender=1   if tp_sexo_2015==2 & gender==0 
	recode  check_gender .=0 if  gender!=.	

	***Gender correctiion
	egen min_gender= rowmin(tp_sexo_2013 tp_sexo_2012 tp_sexo_2011 tp_sexo_2014 tp_sexo_2015 tp_sexo_2016 tp_sexo_2017 tp_sexo_2018)	
	
	gen      gender_inep =1  if min_gender==1
	replace  gender_inep =0  if min_gender==2
	replace  gender_inep=gender if min_gender==.
	lab var gender_inep "Gender: male- corrected using INEP data"
	
	tab gender_inep gender, mis
	tab gender_inep gender if d==1, mis 
	tab gender_inep gender if d==0, mis 

	gen mark_gender_correct=1 if gender_inep!= gender & min_gender!=.
	
	tab mark_gender_correct d
	
	lab var mark_gender_correct "Mark- gender correction"

*****************	
**Color
*****************	
	
	foreach var in	tp_cor_raca_2013 tp_cor_raca_2012 tp_cor_raca_2011 tp_cor_raca_2014 tp_cor_raca_2015 tp_cor_raca_2016 tp_cor_raca_2017 tp_cor_raca_2018 {
	tab `var'
	recode `var' 0=.
	}
	egen min_color =rowmin(tp_cor_raca_2013 tp_cor_raca_2012 tp_cor_raca_2011 tp_cor_raca_2014 tp_cor_raca_2015 tp_cor_raca_2016 tp_cor_raca_2017 tp_cor_raca_2018)	
	
	gen      color_white_inep =1          if min_color==1
	replace  color_white_inep =0          if min_color>1 & min_color!=.
	replace  color_white_inep=color_white if min_color==.
	
	
	lab var color_white_inep "Color-white: corrected using INEP data"
	
	tab color_white_inep color_white, mis
	tab color_white_inep color_white if d==1, mis 
	tab color_white_inep color_white if d==0, mis 

	gen mark_color_correct=1 if color_white_inep!= color_white & min_color!=.
	
	tab mark_color_correct d
*****************		
**Adequate age
*****************	

	gen 	adequate_age_inep=1 if grade_sit_2015== 5 &	nu_idade_referencia_2015<=	11
	replace adequate_age_inep=1 if grade_sit_2015== 6 &	nu_idade_referencia_2015<=	12
	replace adequate_age_inep=1 if grade_sit_2015== 7 &	nu_idade_referencia_2015<=	13
	replace adequate_age_inep=1 if grade_sit_2015== 8 &	nu_idade_referencia_2015<=	14
	replace adequate_age_inep=1 if grade_sit_2015== 9 &	nu_idade_referencia_2015<=	15
	lab var adequate_age_inep "Adequate age for their grade- INEP data"

	*Gen Redo e Dropout before 2015
	gen      idade_inep_2015= nu_idade_referencia_2015
	replace  idade_inep_2015=. if nu_idade_referencia_2015>=30
	lab var  idade_inep_2015 "Age - INPE data"
		

		
*************************************************************************************	
	
	drop check_school
	drop check_grade
	drop check_gender
	drop min_gender
	drop min_color
	
	
**************************************************************************************************************************
**************************************************************************************************************************
*-------------------------------------------------------------------------------------------------------------------------
*D-FINALCIAL LITERACY
*-------------------------------------------------------------------------------------------------------------------------
**************************************************************************************************************************
**************************************************************************************************************************


	**Disciplina do professor
	gen       class_mt=1   if prof1_rp_08==9
	recode    class_mt .=0 if prof1_rp_08!=. &  prof1_rp_08!=.a &  prof1_rp_08!=.b
	
	gen       class_lp=1   if prof1_rp_08==1
	recode    class_lp .=0 if prof1_rp_08!=. &  prof1_rp_08!=.a &  prof1_rp_08!=.b
	
	gen       class_ot=1   if (prof1_rp_08!=9 & prof1_rp_08!=1) & (prof1_rp_08!=. &  prof1_rp_08!=.a &  prof1_rp_08!=.b)
	recode    class_ot .=0 if prof1_rp_08!=. &  prof1_rp_08!=.a &  prof1_rp_08!=.b

	gen      d_class=1 if class_mt==1 & d==1
	replace  d_class=2 if class_lp==1 & d==1
	replace  d_class=3 if class_ot==1 & d==1
	replace  d_class=0 if d==0
	
	lab define d_class 1 "Math" 2"LP" 3 "Other" 0 "Control", replace
	lab val d_class d_class
	
 **************************************************************************************************************************
**************************************************************************************************************************
*-------------------------------------------------------------------------------------------------------------------------
*E-FOR REGRESSIONS
*-------------------------------------------------------------------------------------------------------------------------
**************************************************************************************************************************
**************************************************************************************************************************
	
	***TOP e BOTTOM DAS DISTRIBUIÇÕES
	foreach var of varlist  sm   	{ //pca_consump_sm pca_save_sm  mt_pb_sm_2011 lp_pb_sm_2011  mt_pb_sm_2013 lp_pb_sm_2013   avg_pb_sm_2011 avg_pb_sm_2013 
	gen top50_`var'=.
	}
	
	****************************************
	*3GRADE
	****************************************
	
	
	local s=3
	foreach var of varlist  sm   {

	sum `var'  if serie==`s', det
	
	replace top50_`var'=1 if  `var'>=`r(p50)' & serie==`s'
	replace top50_`var'=0 if  `var'<`r(p50)'  & serie==`s'
	}
	

	****************************************
	*5GRADE
	****************************************
	local s=5
	foreach var of varlist  sm pca_consump_sm pca_save_sm   {
	
	sum `var'  if serie==`s', det
	
	replace top50_`var'=1 if  `var'>=`r(p50)' & serie==`s'
	replace top50_`var'=0 if  `var'<`r(p50)'  & serie==`s'
	}

	****************************************
	*7GRADE
	****************************************
	local s=7
	foreach var of varlist  sm  {
	
	sum `var'  if serie==`s', det
	
	replace top50_`var'=1 if  `var'>=`r(p50)' & serie==`s'
	replace top50_`var'=0 if  `var'<`r(p50)'  & serie==`s'
	}

	
	****************************************
	*9GRADE
	****************************************
	local s=9
	foreach var of varlist  sm pca_consump_sm pca_save_sm mt_pb_sm_2011 lp_pb_sm_2011 avg_pb_sm_2011  {
	
	sum `var'  if serie==`s', det
	
	replace top50_`var'=1 if  `var'>=`r(p50)' & serie==`s'
	replace top50_`var'=0 if  `var'<`r(p50)'  & serie==`s'
	}

tab top50_lp_pb_sm_2011
	
	
	****************************************
	*Treamtment interactions
	****************************************
	
	/*foreach var in class_mt class_lp class_ot  sm  pca_consump_sm pca_save_sm   /// 
				   in_pb_2011 in_pb_2013  in_pb_2015 in_pb_2017   ///
				   mt_pb_sm_2011 lp_pb_sm_2011 mt_pb_sm_2013 lp_pb_sm_2013  ///
				   gender_inep color_white_inep ///
				   top50_sm top50_pca_consump_sm top50_pca_save_sm ///
				   top50_mt_pb_sm_2011 top50_lp_pb_sm_2011 top50_mt_pb_sm_2013 top50_lp_pb_sm_2013 ///
				   top50_mt_pb_sm_2015 top50_lp_pb_sm_2015 top50_mt_pb_sm_2017 top50_lp_pb_sm_2017 {

				gen t_`var'=d*`var'
								}

				
	*/		
				
				
	
				

	
	save "$dtfinal\Fin_Lit_INEP_merge.dta", replace

