/*_______________________________________________________________________________________________________________________________________________________________*

*FINANCIAL LITERACY +INEP 
ANALYSIS
	
*Writen by: Isabela Furtado   -  isabelabfurtado@gmail.com using stata17

*_______________________________________________________________________________________________________________________________________________________________*/


*-------------------------------------------------------------------------------------------------------------------------
*A) FOR EACH MERGE: CHECK BALANCE IN ATRITO: FLUXO, PB2011, PB2013, PB2015, PB2017
*-------------------------------------------------------------------------------------------------------------------------
set more off, perm
	use  "$dtfinal\Fin_Lit_INEP_merge_old.dta",clear
	

	gen f_score= 1 if fl_blank_score==0
	gen f_socio=1  if fl_socio_blank==0
	gen f_parent=1 if fl_blank_parent==0
	
	recode f_score .=0
	recode f_socio .=0
	recode f_parent .=0

	gen      fl_test = 1 if (fl_blank_score==0 | fl_blank_parent==0) & serie==3
	replace  fl_test = 1 if (fl_blank_score==0 | fl_socio_blank==0)  & serie>=5
	recode   fl_test .=0
	
	lab var f_score  "Flag: blanck FL score"
	lab var f_socio  "Flag: blanck socioeconomic quest"
	lab var fl_test  "Flag: blanck FL score or socio or parent"
	lab var f_parent "Flag: blanck parents quest"

	recode mark_gender_correct .=0
	recode mark_color_correct  .=0
	
	
*-----------------------------------------------------------------------------------------------------------------
*1) T-test
*-----------------------------------------------------------------------------------------------------------------

	**Temp adjustment: multiply by 100
	local dummies hh_paved_street hh_electri hh_piped_water hh_garb_col bolsa_fam adequate_age  resp_educ_1 resp_educ_2 resp_educ_3 resp_age_1 resp_age_2 resp_age_3  resp_occup_1 resp_occup_2 resp_occup_3 mother_educ_1 mother_educ_2 mother_educ_3 gender gender_inep color_white color_white_inep in_inep  in_fluxo in_pb_2011 in_pb_2013 in_pb_2015 in_pb_2017 graduate_em3   in_enem_2018 redo dropout  redo_or_dropout eja  mark_gender_correct mark_color_correct transf f_score f_parent  f_socio 
		
	foreach var of local dummies {
	replace `var' = `var'*100 
	}
	
	*-------------
	*A-Grades
	*--------------
	
	foreach grade in 3  5 7 9 {

		estimates clear

		if `grade' == 3 local variables hh_paved_street hh_electri hh_piped_water hh_garb_col bolsa_fam adequate_age  idade_inep_2015  resp_educ_1 resp_educ_2 resp_educ_3 resp_age_1 resp_age_2 resp_age_3  resp_occup_1 resp_occup_2 resp_occup_3  gender_inep  color_white_inep in_inep in_fluxo in_pb_2017 lp_pb_sm_2017 vl_pr_lp_pb_2017 mt_pb_sm_2017 vl_pr_mt_pb_2017 avg_pb_sm_2017 redo dropout  redo_or_dropout eja  transf sm  f_score f_parent
				
		if `grade' == 5 local variables hh_paved_street hh_electri hh_piped_water hh_garb_col bolsa_fam adequate_age  idade_inep_2015 mother_educ_1 mother_educ_2 mother_educ_3 gender gender_inep color_white color_white_inep in_inep  in_fluxo  in_pb_2015 lp_pb_sm_2015 vl_pr_lp_pb_2015 mt_pb_sm_2015 vl_pr_mt_pb_2015 avg_pb_sm_2015 redo dropout  redo_or_dropout eja mark_gender_correct mark_color_correct transf  sm  pca_consump_sm pca_save_sm  f_score  f_socio
				
		if `grade' == 7 local variables hh_paved_street hh_electri hh_piped_water hh_garb_col bolsa_fam adequate_age idade_inep_2015  mother_educ_1 mother_educ_2 mother_educ_3 gender gender_inep color_white color_white_inep in_inep in_fluxo in_pb_2013 lp_pb_sm_2013 vl_pr_lp_pb_2013 mt_pb_sm_2013 vl_pr_mt_pb_2013  avg_pb_sm_2013 in_pb_2017  lp_pb_sm_2017 vl_pr_lp_pb_2017 mt_pb_sm_2017 vl_pr_mt_pb_2017 avg_pb_sm_2017 redo dropout  redo_or_dropout eja mark_gender_correct mark_color_correct transf  sm  pca_consump_sm  pca_save_sm f_score f_socio 
				
		if `grade' == 9 local variables hh_paved_street hh_electri hh_piped_water hh_garb_col bolsa_fam adequate_age idade_inep_2015  mother_educ_1 mother_educ_2 mother_educ_3 gender gender_inep color_white color_white_inep in_inep in_fluxo in_pb_2011 lp_pb_sm_2011 vl_pr_lp_pb_2011 mt_pb_sm_2011 vl_pr_mt_pb_2011 avg_pb_sm_2011 in_pb_2015  lp_pb_sm_2015 vl_pr_lp_pb_2015 mt_pb_sm_2015 vl_pr_mt_pb_2015 avg_pb_sm_2015 graduate_em3  in_enem_2018  enem_mt_sm_2018 enem_lc_sm_2018 enem_cn_sm_2018 enem_ch_sm_2018  avg_enem_sm_2018 enem_mt_sm enem_lc_sm enem_cn_sm enem_ch_sm avg_enem_sm redo dropout  redo_or_dropout eja mark_gender_correct mark_color_correct transf  sm  pca_consump_sm pca_save_sm   f_score   f_socio
			
			
		****GENERAL 	
			preserve
				iebaltab `variables' if serie == `grade' 								, format(%12.2f) grpvar(d)       total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: -") 	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_serie`grade'.xls", replace cell(A1) 
			restore	
			
			preserve	
				iebaltab `variables' if serie == `grade' 								, format(%12.2f) grpvar(d_class) total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: -")
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_serie`grade'.xls",  sheetmodify cell(J1)
			restore	
				
		***FLUXO
			preserve
				iebaltab `variables' if serie == `grade' &  in_fluxo==100				, format(%12.2f) grpvar(d)       total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_fluxo==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_fluxo_serie`grade'.xls", replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_fluxo==100 				, format(%12.2f) grpvar(d_class) total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_fluxo==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_fluxo_serie`grade'.xls", sheetmodify cell(J1)	
			restore	

		*****SAEB
		*9 ano
		if `grade' == 9 {
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2011==100 			, format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2011==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2011==100 			 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2011==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",sheetmodify cell(J1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2015==100 			, format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2015==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",sheetmodify cell(AB1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2015==100 			 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2015==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",sheetmodify cell(AK1)	
			restore	
			
		}
		*7ano
		if `grade' == 7 {
			preserve	
				iebaltab `variables' if serie == `grade' &  in_pb_2013==100 			, format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2013==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2013==100 			 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2013==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",sheetmodify cell(J1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2017==100 			, format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2017==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",sheetmodify cell(AB1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2017==100 			 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2017==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",sheetmodify cell(AK1)	
			restore	
		}
			
		*5ano	
		if `grade' == 5{
			preserve	
				iebaltab `variables' if serie == `grade' &  in_pb_2015==100 			, format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2015==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2015==100 			 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2015==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",sheetmodify cell(J1)	
			restore	
		}

		**3 ano
		if `grade' == 3{
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2017==100 			, format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2017==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' &  in_pb_2017==100 			 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2017==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_I_SAEB_serie`grade'.xls",sheetmodify cell(J1)	
			restore	
		}
				
			
			

			
			
			
		******************************************************************************************************************************************************************************	
		**#***fl_test==1
		******************************************************************************************************************************************************************************

		****GENERAL 	
			preserve
				iebaltab `variables' if serie == `grade' & fl_test==1	 				, format(%12.2f) grpvar(d)       total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: fl_test==1") 	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_serie`grade'.xls", replace cell(A1) 
			restore	
			
			preserve	
				iebaltab `variables' if serie == `grade' & fl_test==1					, format(%12.2f) grpvar(d_class) total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: fl_test==1")
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_serie`grade'.xls",  sheetmodify cell(J1)
			restore	
				
		***FLUXO
			preserve
				iebaltab `variables' if serie == `grade' & fl_test==1 &  in_fluxo==100	, format(%12.2f) grpvar(d)       total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: fl_test==1 &  in_fluxo==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_fluxo_serie`grade'.xls", replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade' & fl_test==1 &  in_fluxo==100 	, format(%12.2f) grpvar(d_class) total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional:  fl_test==1 &  in_fluxo==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_fluxo_serie`grade'.xls", sheetmodify cell(J1)	
			restore	

			
			
		*****SAEB
		*9 ano
		if `grade'  & fl_test==1 == 9{
			preserve
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2011==100 , format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2011==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2011==100 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2011==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",sheetmodify cell(J1)	
			restore	
			
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2015==100 , format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2015==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",sheetmodify cell(AB1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2015==100 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2015==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",sheetmodify cell(AK1)	
			restore	
			
		}
		*7ano
		if `grade'  & fl_test==1 == 7{
			preserve
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2013==100 , format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2013==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2013==100 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2013==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",sheetmodify cell(J1)	
			restore	
			
			preserve	
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2017==100 , format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2017==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'",sheetmodify cell(AB1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2017==100  , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2017==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",sheetmodify cell(AK1)	
			restore	
		}
			
		*5ano	
		if `grade'  & fl_test==1 == 5{
			preserve	
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2015==100 , format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2015==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2015==100 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2015==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",sheetmodify cell(J1)	
			restore	
		}

		**3 ano
		if `grade'  & fl_test==1 == 3{
			preserve	
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2017==100 , format(%12.2f) grpvar(d)        total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2017==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",replace cell(A1)	
			restore	
			
			preserve
				iebaltab `variables' if serie == `grade'  & fl_test==1 &  in_pb_2017==100 , format(%12.2f) grpvar(d_class)  total cov($estrato) vce(cluster cd_escola) rowvarlabels browse tblnote ("Conditional: in_pb_2017==1")	
				export excel using "T:\Output\Tables\Descriptives\June\Balance_Teste_II_SAEB_serie`grade'.xls",sheetmodify cell(J1)	
			restore	
		}
	}
	